## ninjas2-0.2.0-2.src.tar.gz

=== Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#
# Modified by Clearly Broken Software
#

include dpf/Makefile.base.mk

all: libs plugins gen

define MISSING_SUBMODULES_ERROR

Cannot find DGL! Please run "make submodules" to clone the missing submodules, then retry building the plugin.

endef

# --------------------------------------------------------------
submodules: 
	git submodule update --init --recursive

libs:
ifeq (,$(wildcard dpf/dgl))
	$(error $(MISSING_SUBMODULES_ERROR))
endif

ifneq ($(USE_SYSTEM_AUBIO),true)
	$(MAKE) -C aubio
endif

ifeq ($(HAVE_OPENGL),true)
	$(MAKE) -C dpf/dgl
endif

plugins: libs
	$(MAKE) all -C plugins/Ninjas2

gen: plugins dpf/utils/lv2_ttl_generator
	@$(CURDIR)/dpf/utils/generate-ttl.sh
ifeq ($(MACOS),true)
	@$(CURDIR)/dpf/utils/generate-vst-bundles.sh
endif

dpf/utils/lv2_ttl_generator:
	$(MAKE) -C dpf/utils/lv2-ttl-generator

# --------------------------------------------------------------

clean:
ifneq ($(USE_SYSTEM_AUBIO),true)
	$(MAKE) clean -C aubio
endif
ifeq ($(HAVE_OPENGL),true)
	$(MAKE) clean -C dpf/dgl
endif
	$(MAKE) clean -C dpf/utils/lv2-ttl-generator
	$(MAKE) clean -C plugins/Ninjas2


# --------------------------------------------------------------

.PHONY: plugins

=== aubio/Makefile ===
#!/usr/bin/make -f
# Makefile for static aubio #
# ------------------------- #
# Created by falkTX
#

include ../dpf/Makefile.base.mk

# --------------------------------------------------------------

BUILD_C_FLAGS += -Isrc -DHAVE_CONFIG_H

OBJS = \
	src/cvec.c.o \
	src/fmat.c.o \
	src/fvec.c.o \
	src/lvec.c.o \
	src/mathutils.c.o \
	src/vecutils.c.o \
	src/io/audio_unit.c.o \
	src/io/ioutils.c.o \
	src/io/sink.c.o \
	src/io/sink_apple_audio.c.o \
	src/io/sink_sndfile.c.o \
	src/io/sink_wavwrite.c.o \
	src/io/source.c.o \
	src/io/source_apple_audio.c.o \
	src/io/source_avcodec.c.o \
	src/io/source_sndfile.c.o \
	src/io/source_wavread.c.o \
	src/io/utils_apple_audio.c.o \
	src/notes/notes.c.o \
	src/onset/onset.c.o \
	src/onset/peakpicker.c.o \
	src/pitch/pitch.c.o \
	src/pitch/pitchfcomb.c.o \
	src/pitch/pitchmcomb.c.o \
	src/pitch/pitchschmitt.c.o \
	src/pitch/pitchspecacf.c.o \
	src/pitch/pitchyin.c.o \
	src/pitch/pitchyinfast.c.o \
	src/pitch/pitchyinfft.c.o \
	src/spectral/awhitening.c.o \
	src/spectral/fft.c.o \
	src/spectral/filterbank.c.o \
	src/spectral/filterbank_mel.c.o \
	src/spectral/mfcc.c.o \
	src/spectral/ooura_fft8g.c.o \
	src/spectral/phasevoc.c.o \
	src/spectral/specdesc.c.o \
	src/spectral/statistics.c.o \
	src/spectral/tss.c.o \
	src/synth/sampler.c.o \
	src/synth/wavetable.c.o \
	src/tempo/beattracking.c.o \
	src/tempo/tempo.c.o \
	src/temporal/a_weighting.c.o \
	src/temporal/biquad.c.o \
	src/temporal/c_weighting.c.o \
	src/temporal/filter.c.o \
	src/temporal/resampler.c.o \
	src/utils/hist.c.o \
	src/utils/log.c.o \
	src/utils/parameter.c.o \
	src/utils/scale.c.o \
	src/utils/windll.c.o

# --------------------------------------------------------------

%.c.o: %.c
	$(CC) $< $(BUILD_C_FLAGS) -MD -MP -c -o $@

# --------------------------------------------------------------

all: libaubio.a

clean:
	rm -f *.a src/*.d src/*.o src/*/*.d src/*/*.o

libaubio.a: $(OBJS)
	rm -f $@
	$(AR) crs $@ $^

# --------------------------------------------------------------

-include $(OBJS:%.o=%.d)

# --------------------------------------------------------------

=== dpf/Makefile ===
#!/usr/bin/make -f
# Makefile for DPF #
# ---------------- #
# Created by falkTX
#

include Makefile.base.mk

all: dgl examples gen

# --------------------------------------------------------------

dgl:
	$(MAKE) -C dgl

examples: dgl
	$(MAKE) all -C examples/Info
	$(MAKE) all -C examples/Latency
	$(MAKE) all -C examples/Meters
	$(MAKE) all -C examples/MidiThrough
	$(MAKE) all -C examples/Parameters
	$(MAKE) all -C examples/SendNote
	$(MAKE) all -C examples/States

ifeq ($(HAVE_CAIRO),true)
	$(MAKE) all -C examples/CairoUI
endif

ifneq ($(MACOS_OR_WINDOWS),true)
	# ExternalUI is WIP
	$(MAKE) all -C examples/ExternalUI
	install -d bin/d_extui-dssi
	install -d bin/d_extui.lv2
	install -m 755 examples/ExternalUI/ExternalLauncher.sh bin/d_extui.sh
	install -m 755 examples/ExternalUI/ExternalLauncher.sh bin/d_extui-dssi/d_extui.sh
	install -m 755 examples/ExternalUI/ExternalLauncher.sh bin/d_extui.lv2/d_extui.sh
endif

ifneq ($(CROSS_COMPILING),true)
gen: examples utils/lv2_ttl_generator
	@$(CURDIR)/utils/generate-ttl.sh
ifeq ($(MACOS),true)
	@$(CURDIR)/utils/generate-vst-bundles.sh
endif

utils/lv2_ttl_generator:
	$(MAKE) -C utils/lv2-ttl-generator
else
gen:
endif

# --------------------------------------------------------------

clean:
	$(MAKE) clean -C dgl
	$(MAKE) clean -C examples/CairoUI
	$(MAKE) clean -C examples/Info
	$(MAKE) clean -C examples/Latency
	$(MAKE) clean -C examples/Meters
	$(MAKE) clean -C examples/MidiThrough
	$(MAKE) clean -C examples/Parameters
	$(MAKE) clean -C examples/SendNote
	$(MAKE) clean -C examples/States
	$(MAKE) clean -C utils/lv2-ttl-generator
ifneq ($(MACOS_OR_WINDOWS),true)
	$(MAKE) clean -C examples/ExternalUI
endif
	rm -rf bin build

# --------------------------------------------------------------

.PHONY: dgl examples

=== deps/libsamplerate-master/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(libsamplerate VERSION 0.1.9 LANGUAGES C)

option(LIBSAMPLERATE_TESTS "Enable to generate test targets" ON)
option(LIBSAMPLERATE_INSTALL "Enable to add install directives" ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(TestBigEndian)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckTypeSize)
include(ClipMode)

set(SAMPLERATE_SRC
	${PROJECT_SOURCE_DIR}/src/samplerate.c
	${PROJECT_SOURCE_DIR}/src/src_linear.c
	${PROJECT_SOURCE_DIR}/src/src_sinc.c
	${PROJECT_SOURCE_DIR}/src/src_zoh.c)

if(WIN32)
	set(OS_IS_WIN32 TRUE)
	set(SAMPLERATE_SRC
		${SAMPLERATE_SRC}
		${PROJECT_SOURCE_DIR}/Win32/libsamplerate-0.def)
	include_directories(Win32)
endif()

test_big_endian(CPU_IS_BIG_ENDIAN)
if(CPU_IS_BIG_ENDIAN)
	set(CPU_IS_LITTLE_ENDIAN 0)
else()
	set(CPU_IS_LITTLE_ENDIAN 1)
endif()

check_function_exists(pow RESULT)
if(NOT RESULT)
  list(APPEND CMAKE_REQUIRED_LIBRARIES m)
  set(NEED_MATH)
endif()
check_function_exists(alarm HAVE_ALARM)
check_function_exists(lrint HAVE_LRINT)
check_function_exists(lrintf HAVE_LRINTF)
check_function_exists(signal HAVE_SIGNAL)

check_include_files(stdint.h HAVE_STDINT)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)

check_symbol_exists(SIGALRM signal.h HAVE_SIGALRM)

check_type_size(int SIZEOF_INT)
check_type_size(long SIZEOF_LONG)

# This will set CPU_CLIPS_NEGATIVE and CPU_CLIPS_POSITIVE
clip_mode()

find_package(ALSA)
set(HAVE_ALSA ${ALSA_FOUND})
if(ALSA_FOUND)
  include_directories("${ALSA_INCLUDE_DIR}")
endif()

find_package(Sndfile)
set(HAVE_SNDFILE ${SNDFILE_FOUND})
if(SNDFILE_FOUND)
  include_directories("${SNDFILE_INCLUDE_DIR}")
endif()

find_package(FFTW)
set(HAVE_FFTW3 ${FFTW_FOUND})
if(FFTW_FOUND)
  include_directories("${FFTW_INCLUDE_DIR}")
endif()

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_library(samplerate ${SAMPLERATE_SRC})

if(BUILD_SHARED_LIBS AND WIN32)
	if (MSVC)
		set_target_properties(samplerate PROPERTIES OUTPUT_NAME "libsamplerate-0")
	else()
		set_target_properties(samplerate PROPERTIES OUTPUT_NAME "samplerate-0")
	endif()
endif()

target_include_directories(samplerate PUBLIC
	${PROJECT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR})
    
if(LIBSAMPLERATE_TESTS)

enable_testing()

file(GLOB TEST_SRCS ${PROJECT_SOURCE_DIR}/tests/*_test.c)

foreach(testSrc ${TEST_SRCS})
	get_filename_component(testName ${testSrc} NAME_WE)
	add_executable(${testName}
		${testSrc}
		${PROJECT_SOURCE_DIR}/tests/util.c
		${PROJECT_SOURCE_DIR}/tests/calc_snr.c)
	target_link_libraries(${testName} PUBLIC samplerate ${CMAKE_REQUIRED_LIBRARIES})
	if(FFTW_FOUND)
		target_link_libraries(${testName} PUBLIC ${FFTW_LIBRARY})
	endif()
	add_test(NAME ${testName} COMMAND ${testName})
endforeach(testSrc)

set(EXAMPLE_SRCS
	${PROJECT_SOURCE_DIR}/examples/timewarp-file.c
	${PROJECT_SOURCE_DIR}/examples/varispeed-play.c)

foreach(exampleSrc ${EXAMPLE_SRCS})
	get_filename_component(exampleName ${exampleSrc} NAME_WE)
	add_executable(${exampleName}
		${exampleSrc}
		${PROJECT_SOURCE_DIR}/examples/audio_out.c)
	target_link_libraries(${exampleName} PUBLIC samplerate ${CMAKE_REQUIRED_LIBRARIES})
	if(ALSA_FOUND)
		target_link_libraries(${exampleName} PUBLIC ${ALSA_LIBRARY})
	endif()
	if(SNDFILE_FOUND)
		target_link_libraries(${exampleName} PUBLIC ${SNDFILE_LIBRARY})
	endif()
	if(WIN32)
		target_link_libraries(${exampleName} PUBLIC winmm)
	endif()
	if (APPLE)
		target_link_libraries (${exampleName} PUBLIC  "-framework CoreAudio")
	endif()
endforeach(exampleSrc)
endif() 

if(LIBSAMPLERATE_INSTALL)
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(includedir "\${prefix}/include")
set(libdir "\${exec_prefix}/lib")
set(VERSION "${PROJECT_VERSION}")
if(NEED_MATH)
	set(LIBS "-lm")
endif()
configure_file(samplerate.pc.in samplerate.pc @ONLY)

install(TARGETS samplerate DESTINATION lib)
install(FILES src/samplerate.h DESTINATION include)
install(DIRECTORY doc/ DESTINATION share/doc/libsamplerate)
install(FILES ${CMAKE_BINARY_DIR}/samplerate.pc DESTINATION lib/pkgconfig)

endif()

=== plugins/Ninjas2/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#
# Modified by Clearly Broken Software
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = ninjas2

# --------------------------------------------------------------
# Plugin types to build

BUILD_LV2 ?= true
BUILD_VST2 ?= true
BUILD_JACK ?= true
BUILD_DSSI ?= false
BUILD_LADSPA = false

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	Ninjas2Plugin.cpp

FILES_UI  = \
	Utils/src/Mathf.cpp \
	Structures/src/Animation.cpp \
	Structures/src/Layout.cpp \
	Widgets/src/WolfWidget.cpp \
	Widgets/src/NanoSwitch.cpp \
	Widgets/src/RemoveDCSwitch.cpp \
	Widgets/src/NanoButton.cpp \
	Widgets/src/NanoWheel.cpp \
	Widgets/src/NanoKnob.cpp \
	Widgets/src/VolumeKnob.cpp \
	Widgets/src/ResizeHandle.cpp \
	Widgets/src/LabelBox.cpp \
	Widgets/src/LabelContainer.cpp \
	Widgets/src/BipolarModeSwitch.cpp \
	Widgets/src/GlowingLabelsBox.cpp \
	Widgets/src/NanoLabel.cpp \
	Widgets/src/SpinBox.cpp \
	Widgets/src/NanoSpinBox.cpp \
	Widgets/src/TextButton.cpp \
	Widgets/src/PlayModeSwitch.cpp \
	Resources/fonts.cpp \
	Widgets/src/StateSwitch.cpp \
	Widgets/src/PianoKeyboard.cpp \
	Widgets/src/LabelBox.cpp \
	Ninjas2UI.cpp \
	Ninjas2Resources.cpp
	

# --------------------------------------------------------------
# Do some magic

include ../../dpf/Makefile.plugins.mk

# --------------------------------------------------------------
# Extra flags

BASE_FLAGS += -I. -I./Widgets -I./Utils -I./Structures

# TODO: change pkg-config to $(PKG_CONFIG) with updated DPF
ifeq ($(USE_SYSTEM_AUBIO),true)
BASE_FLAGS += $(shell $(PKG_CONFIG) --cflags-only-other aubio) \
              -I$(shell $(PKG_CONFIG) --variable includedir aubio)/aubio
LINK_FLAGS += $(shell $(PKG_CONFIG) --libs aubio)
else
BASE_FLAGS += -I../../aubio/src
LINK_FLAGS += ../../aubio/libaubio.a
endif

BASE_FLAGS += $(shell $(PKG_CONFIG) --cflags sndfile samplerate )
LINK_FLAGS += $(shell $(PKG_CONFIG) --libs sndfile samplerate )

# Set PARANOID_MODE=true to make the build error out on warnings
ifeq ($(PARANOID_MODE),true)
BASE_FLAGS += -Wall -Wextra -Werror
endif

# --------------------------------------------------------------
# Enable all possible plugin types

ifeq ($(BUILD_JACK),true)
ifeq ($(HAVE_JACK),true)
TARGETS += jack
endif
endif

ifeq ($(BUILD_LADSPA),true)
TARGETS += ladspa
endif

ifeq ($(BUILD_DSSI),true)
ifeq ($(HAVE_OPENGL),true)
ifeq ($(HAVE_LIBLO),true)
TARGETS += dssi
endif
endif
endif

ifeq ($(BUILD_LV2),true)
ifeq ($(HAVE_OPENGL),true)
TARGETS += lv2
else
TARGETS += lv2_dsp
endif
endif


ifeq ($(BUILD_VST2),true)
TARGETS += vst
endif

all: $(TARGETS)

# --------------------------------------------------------------

=== dpf/examples/SendNote/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = d_sendNote

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	SendNoteExamplePlugin.cpp


FILES_UI  = \
	SendNoteExampleUI.cpp

# --------------------------------------------------------------
# Do some magic

include ../../Makefile.plugins.mk

# --------------------------------------------------------------
# Enable all possible plugin types

ifeq ($(HAVE_JACK),true)
ifeq ($(HAVE_OPENGL),true)
TARGETS += jack
endif
endif

ifeq ($(HAVE_OPENGL),true)
TARGETS += lv2_sep
else
TARGETS += lv2_dsp
endif

TARGETS += vst

all: $(TARGETS)

# --------------------------------------------------------------

=== PKGBUILD ===
# Maintainer: David Runge <dvzrv@archlinux.org>

pkgname=ninjas2
pkgver=0.2.0
pkgrel=2
pkgdesc="A sample slicer audio plugin"
arch=('x86_64')
url="https://github.com/rghvdberg/ninjas2"
license=('GPL3')
groups=('lv2-plugins' 'pro-audio' 'vst-plugins')
depends=('gcc-libs' 'glibc' 'libglvnd' 'libx11')
makedepends=('aubio' 'gendesk' 'jack' 'libsamplerate' 'libsndfile')
checkdepends=('lv2lint')
optdepends=('jack: for standalone application'
            'lv2-host: for LV2 plugin'
            'vst-host: for VST plugin')
source=("https://github.com/rghvdberg/${pkgname}/releases/download/v${pkgver}/${pkgname}-v${pkgver}-source.zip")
sha512sums=('b05c4d2eaba91a1104cb2700b857e0b428a9bb574973616c1477a6c993c6290bb31343f071d0607c0d6c21830fd29523d814aff2bb12442a8ca45e06efd75506')
b2sums=('aac12947bbb217b22a81a6c53801cfd39e11ed37fbc63b5882825b918d5033517f62cd1c8479cd87e6af5410f78e1481eb28e0b73f6afa21c49a837829fdb218')

prepare() {
  mv -v "${pkgname}-v${pkgver}" "${pkgname}-${pkgver}"
  cd "$pkgname-$pkgver"
  # Removing the local aubio version from the plugin Makefile
  sed -e '/libaubio.a/d' \
      -e 's|-I../../aubio/src||' \
      -e 's/sndfile/aubio sndfile/g' \
      -i plugins/Ninjas2/Makefile
  # adding the system headers for aubio
  sed -e 's|"aubio.h"|<aubio/aubio.h>|g' \
      -i plugins/Ninjas2/*.{c,h}pp
  gendesk -n \
          --pkgname "${pkgname}" \
          --name "Ninjas2" \
          --genericname "Sample Slicer" \
          --categories "AudioVideo;Audio"
}

build() {
  cd "$pkgname-$pkgver"
  make
}

check() {
  cd "$pkgname-$pkgver"
  # lv2lint segfaults on the plugin :(
  # https://github.com/clearly-broken-software/ninjas2/issues/76
  # lv2lint -Mpack -I "${PWD}/bin/${pkgname}.lv2/" "https://github.com/rghvdberg/ninjas2"
}

package() {
  depends+=('libaubio.so' 'libsamplerate.so' 'libsndfile.so')
  cd "$pkgname-$pkgver"
  install -vDm 755 "bin/${pkgname}" -t "${pkgdir}/usr/bin"
  install -vDm 755 "bin/${pkgname}-vst.so" -t "${pkgdir}/usr/lib/vst"
  install -vDm 755 "bin/${pkgname}.lv2/"*.so \
    -t "${pkgdir}/usr/lib/lv2/${pkgname}.lv2"
  install -vDm 644 "bin/${pkgname}.lv2/"*.ttl \
    -t "${pkgdir}/usr/lib/lv2/${pkgname}.lv2"
  install -vDm 644 "${pkgname}.desktop" \
    -t "${pkgdir}/usr/share/applications/"
  install -vDm 644 {AUTHORS,README.md} \
    -t "${pkgdir}/usr/share/doc/${pkgname}"
}
